/*
 * Placeholder for Mozilla Tri-licence: MPL/GPL/LGPL
 * Original code from firefox trunk and seamonkey trunk
*/

// RevealSearchPanel - navigator.js
// isSearchPanelOpen - navigator.js

// Bug 233874 Comment 7
// BTW, while you're rewriting this, can you use the nsIDOMXULElement properties
// such as .id, .hidden and .collapsed wherever possible?

// TODO Put Sidebars in printpreview

var xSidebar = {

  // Hide RDF sidebar elements we don't want to show in the UI
  fixupUI : function () {
/*  
    dump( "sidebar-panels:" + document.getElementById("sidebar-panels") +
    "\nsidebar-title-box:" + document.getElementById("sidebar-title-box") +
    "\nsidebar-panels-splitter-box:" + document.getElementById("sidebar-panels-splitter-box") +
    "\nsidebar-box:" + document.getElementById("sidebar-box") +
    "\nnavigator-toolbox:" + document.getElementById("navigator-toolbox") );
*/
    xSidebar.showItem("sidebar-panels", false);
    var navButtonsBox = document.getElementById("nav-buttons-box");
    if (navButtonsBox)
      xSidebar.showItem(navButtonsBox.parentNode, false);
    xSidebar.showItem("sidebar", true);
  },

  // Merge SeaMonkey and Aviary versions
  toggleAffectedChrome : function (aHide) {

    // chrome to toggle includes:
    //   (*) menubar
    //   (*) navigation bar
    //   (*) personal toolbar
    //   (*) tab browser ``strip''
    //   (*) sidebar
    //   (*) statusbar

    if (!gChromeState)
      gChromeState = new Object;

    var statusbar = document.getElementById("status-bar");
    var navToolbox = document.getElementById("navigator-toolbox");
    navToolbox.hidden = aHide;
    var theTabbrowser = document.getElementById("content"); 

    // Aviary
    var sidebar = document.getElementById("sidebar-box");
    gSidebarCommand = sidebar.getAttribute("sidebarcommand");

    // sidebar states map as follows:
    //   was-hidden    => hide/show nothing
    //   was-collapsed => hide/show only the splitter
    //   was-shown     => hide/show the splitter and the box
    if (aHide)
    {
      // going into print preview mode
      if (sidebar_is_collapsed())
      {
        gChromeState.sidebar = "was-collapsed";
      }
      else if (sidebar_is_hidden())
        gChromeState.sidebar = "was-hidden";
        // gChromeState.sidebarOpen = !sidebar.hidden; // Aviary
      else 
      {
        gChromeState.sidebar = "was-visible";
      }
      sidebar.hidden = true;
      document.getElementById("sidebar-splitter").hidden = true;

      // deal with tab browser
      gChromeState.hadTabStrip = theTabbrowser.getStripVisibility();
      theTabbrowser.setStripVisibilityTo(false);

      // deal with the Status Bar
      gChromeState.statusbarWasHidden = statusbar.hidden;
      statusbar.hidden = true;

      // deal with info bars
      if ("getNotificationBox" in gBrowser) {
        var notificationBox = gBrowser.getNotificationBox();
        gChromeState.notificationsWereHidden = !notificationBox.notificationsHidden;
        notificationBox.notificationsHidden = true;
      }

      // deal with the Find Bar
      if ("gFindBar" in window) {
        gChromeState.findOpen = !gFindBar.hidden;
        gFindBar.close();
      }
    }
    else
    {
      // restore tab browser
      theTabbrowser.setStripVisibilityTo(gChromeState.hadTabStrip);

      // restoring normal mode (i.e., leaving print preview mode)
      if (gChromeState.sidebar == "was-collapsed" ||
          gChromeState.sidebar == "was-visible")
        document.getElementById("sidebar-splitter").hidden = false;
      if (gChromeState.sidebar == "was-visible")
         sidebar.hidden = false;

      // restore the Status Bar
      statusbar.hidden = gChromeState.statusbarWasHidden;

      // restore the info bar
      if ("getNotificationBox" in gBrowser && gChromeState.notificationsWereHidden) {
        gBrowser.getNotificationBox().notificationsHidden = gChromeState.notificationsWereHidden;
      }
    }

    // if we are unhiding and sidebar used to be there rebuild it
    if (!aHide && gChromeState.sidebar == "was-visible")
    {
      // SidebarRebuild();
      xSidebar.toggleSidebar(gSidebarCommand);
    }

  },

  // SeaMonkey replacement function
  SidebarShowHide : function () {
    xSidebar.toggleSidebar();
  },

  // Port Aviary function:
  // |forceOpen| is a bool that indicates that the sidebar should be forced open.  In other words
  // the toggle won't be allowed to close the sidebar.
  toggleSidebar : function (aCommandID, forceOpen) {
    var sidebarBox = document.getElementById("sidebar-box");
    if (!aCommandID)
      aCommandID = sidebarBox.getAttribute("sidebarcommand");
    if (!aCommandID)
      aCommandID = "viewBookmarksSidebar";

    var elt = document.getElementById(aCommandID);
    var sidebar = document.getElementById("sidebar");
    var sidebarTitle = document.getElementById("sidebar-title");// ff sidebar-box>label
    var sidebarTitleBox = document.getElementById("sidebar-title-box"); // sidebarheader
    var sidebarSplitter = document.getElementById("sidebar-splitter");
    var sidebarPanelsSplitter = document.getElementById("sidebar-panels-splitter");
    var sidebarPanelsSplitterBox = document.getElementById("sidebar-panels-splitter-box");
    var sidebarMenuItem = document.getElementById("sidebar-menu");
    var sidebarTabsMenu = document.getElementById("sidebar-panel-picker");

    //XXX Hack because we use the Web Panel to view sidebars from panels.rdf
    var webPanel = document.getElementById("viewWebPanelsSidebar");
    var webPanelId = webPanel.getAttribute("rdfpanel");
    var eltRdf = webPanelId ? document.getElementById(webPanelId) : null;
    var isRdfPanel = (aCommandID == "viewWebPanelsSidebar" && eltRdf);
    var isRdfChecked = isRdfPanel && eltRdf && eltRdf.getAttribute("checked") == "true";

    // dump( "\nxSidebar acommandID is:" + aCommandID + "\nelt is" + elt);
    if (!forceOpen &&
         elt &&
         (elt.getAttribute("checked") == "true" || isRdfChecked)
       ) {
      // Aviary
      if (isRdfChecked)
        eltRdf.removeAttribute("checked");
      else
        elt.removeAttribute("checked");
      // sidebarBox.setAttribute("sidebarcommand", "");
      sidebarTitle.value = "";
      sidebar.removeAttribute("src");

      // SeaMonkey
      var hideEverything = sidebarPanelsSplitter.getAttribute("hidden") == "true";
      if (hideEverything) {
        debug("Hide everything");
        sidebarBox.collapsed = true;
        sidebarBox.hidden = true;
        sidebarSplitter.hidden = true;
      } else {
        sidebarPanelsSplitter.hidden = true;
      }
      //sidebarTitleBox.hidden = true;
      sidebarPanelsSplitterBox.collapsed = true;
      sidebarPanelsSplitterBox.hidden = true; // test
      sidebarMenuItem.setAttribute("checked", "false");
      sidebarTabsMenu.hidden = true;

      xSidebar.setButtonOpen(false);
      window.content.focus();
      return;
    }

    debug("Showing the xSidebar");

    // SeaMonkey
    sidebarBox.hidden = false;
    sidebarPanelsSplitterBox.hidden = false;
    sidebarPanelsSplitterBox.removeAttribute("collapsed");

    sidebarBox.removeAttribute("collapsed");

    sidebarSplitter.hidden = false;
    if (sidebarSplitter.getAttribute("state") == "collapsed")
      sidebarSplitter.removeAttribute("state");

// MailNews sidebar
    var mailnewsSplitter = document.getElementById("gray_vertical_splitter");
    if (mailnewsSplitter) {
      mailnewsSplitter.setAttribute("state", null);
    }

    sidebarTitleBox.hidden = false;

    if (sidebarBox.firstChild != sidebarPanelsSplitter) {
      debug("Showing the xSidebar panels splitter");
      sidebarPanelsSplitter.hidden = false;
      if (sidebarPanelsSplitter.getAttribute("state") == "collapsed")
        sidebarPanelsSplitter.removeAttribute("state");
    }
    //sidebar_overlay_init(); SeaMonkey
    xSidebar.overlayInit();

    sidebarMenuItem.setAttribute("checked", "true");
    sidebarTabsMenu.hidden = false;
    xSidebar.setButtonOpen(true);

    // Hide rdf elements
    xSidebar.fixupUI();
    
    var elts = document.getElementsByAttribute("group", "sidebar");
    for (var i = 0; i < elts.length; i++) {
      if (elts[i].localName != "broadcaster")
        continue;
      elts[i].removeAttribute("checked");
    }

    //XXX Hack because we use the Web Panel to view sidebars from panels.rdf
    if (isRdfPanel)
      eltRdf.setAttribute("checked", "true");
    else
      elt.setAttribute("checked", "true");

    var url = elt.getAttribute("sidebarurl");
    var title = elt.getAttribute("sidebartitle");
    if (!title)
      title = elt.getAttribute("label");
    sidebar.setAttribute("src", url);
    sidebarBox.setAttribute("src", url);
    sidebarBox.setAttribute("sidebarcommand", elt.id);
    sidebarTitle.value = title;
    if (aCommandID != "viewWebPanelsSidebar") { // no searchbox there
      // if the sidebar we want is already constructed, focus the searchbox
      if ((aCommandID == "viewBookmarksSidebar" && sidebar.contentDocument.getElementById("bookmarksPanel"))
      || (aCommandID == "viewHistorySidebar" && sidebar.contentDocument.getElementById("history-panel"))) {
        var searchBox = sidebar.contentDocument.getElementById("search-box");
        if (searchBox)
          searchBox.focus();
      }
      else if (sidebar.contentDocument.documentElement &&
               sidebar.contentDocument.documentElement.getAttribute('elementtofocus')) {
        var elementToFocus = sidebar.contentDocument.documentElement.getAttribute('elementtofocus');
        var element = sidebar.contentDocument.getElementById(elementToFocus);
        if (element)
          element.focus();
      }
      // otherwise, attach an onload handler
      else
        sidebar.addEventListener("load", xSidebar.asyncFocusSearchBox, true);
    }
    // SeaMonkey
    document.persist("sidebar-title-box", "hidden");
    persist_width();
    window.content.focus();

  },

  // called by toggleSidebar
  asyncFocusSearchBox : function (event) {
    var sidebar = document.getElementById("sidebar");
    var searchBox = sidebar.contentDocument.getElementById("search-box");
    if (searchBox)
      searchBox.focus();
    else if (sidebar.contentDocument.documentElement &&
             sidebar.contentDocument.documentElement.getAttribute('elementtofocus')) {
      var elementToFocus = sidebar.contentDocument.documentElement.getAttribute('elementtofocus');
      var element = sidebar.contentDocument.getElementById(elementToFocus);
      if (element)
        element.focus();
    }
    sidebar.removeEventListener("load", xSidebar.asyncFocusSearchBox, true);
  },

  // no need to reimplement?
  setButtonOpen : function (aSidebarNowOpen) {
  // change state so toolbar icon can be updated
    var pt = document.getElementById("PersonalToolbar");
    if (pt) {
      pt.setAttribute("prefixopen", aSidebarNowOpen);

      // set tooltip for toolbar icon
      var header = document.getElementById("sidebar-title-box");
      var tooltip = header.getAttribute(aSidebarNowOpen ? 
                    "tooltipclose" : "tooltipopen");
      pt.setAttribute("prefixtooltip", tooltip);
    }
  },

  replaceToggleSidebar : function () {
    var cmd = document.getElementById("toggleSidebar");
    if (cmd) {
      cmd.setAttribute("oncommand", "xSidebar.toggleSidebar();")
    }
    cmd = document.getElementById("sidebar-close-button");
    if (cmd) {
      cmd.setAttribute("oncommand", "xSidebar.toggleSidebar();")
    }
    cmd = document.getElementById("key_toggleFolderPane");
    if (cmd) {
      cmd.setAttribute("modifiers", "shift")
    }
  },

  overlayInit : function () {
    if (sidebar_is_collapsed() && !gAboutToUncollapse)
      return;
    gMustInit = false;
    sidebarObj.panels = new sbPanelList('sidebar-panels');
    sidebarObj.datasource_uri = get_sidebar_datasource_uri();
    sidebarObj.resource = 'urn:sidebar:current-panel-list';

    sidebarObj.master_datasources = "";
    sidebarObj.master_datasources = get_remote_datasource_url();
    sidebarObj.master_datasources += " chrome://communicator/content/sidebar/local-panels.rdf";
    sidebarObj.master_resource = 'urn:sidebar:master-panel-list';
    sidebarObj.component = document.documentElement.getAttribute('windowtype');
    debug("xSidebar: sidebarObj.component is " + sidebarObj.component);

    // Initialize the display
    var sidebar_element = document.getElementById('sidebar-box');
    var sidebar_menuitem = document.getElementById('sidebar-menu');
    if (sidebar_is_hidden()) {
      if (sidebar_menuitem) {
        sidebar_menuitem.setAttribute('checked', 'false');
      }
    } else {
      if (sidebar_menuitem) {
        sidebar_menuitem.setAttribute('checked', 'true');
      }

      // for old profiles that don't persist the hidden attribute when splitter is not hidden.
      var sidebar_splitter = document.getElementById('sidebar-splitter')
      if (sidebar_splitter)
        sidebar_splitter.hidden = false;
      if (sidebarObj.never_built) {
        sidebarObj.never_built = false;

        debug("sidebar = " + sidebarObj);
        debug("sidebarObj.resource = " + sidebarObj.resource);
        debug("sidebarObj.datasource_uri = " + sidebarObj.datasource_uri);

        // Obtain the pref for limiting the number of tabs in view
        try
        {
          var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefBranch);
          gNumTabsInViewPref = prefs.getIntPref("sidebar.num_tabs_in_view");
        }
        catch (ex)
        {
          gNumTabsInViewPref = 8; // failover default
        }

        // Show the header for the panels area. Use a splitter if there
        // is stuff over the panels area.
        var sidebar_panels_splitter = document.getElementById('sidebar-panels-splitter');
        if (sidebar_element.firstChild != sidebar_panels_splitter) {
          debug("Showing the panels splitter");
          sidebar_panels_splitter.removeAttribute('hidden');
        }
      }
      if (sidebar_is_collapsed()) {
        sidebarObj.collapsed = true;
      } else {
        sidebarObj.collapsed = false;
      }

      /// sidebar_open_default_panel(100, 0);
    }
    xSidebar.replaceToggleSidebar();
  },

  RevealSearchPanel : function () {
    toggleSidebar("viewInternalSearchSidebar", true)
  },
  
  isSearchPanelOpen : function () {
    var sidebar = document.getElementById("sidebar");
    var rv = false;
    if (!sidebar_is_hidden() &&
        !sidebar_is_collapsed() &&
        sidebar &&
        sidebar.getAttribute("sidebarcommand") == "viewInternalSearchSidebar")
      rv = true;
    return rv;
  },

  sidebarSelectPanel: function (panel, should_popopen, should_unhide) {
    dump("\nSidebarSelectPanel("+panel+","+should_popopen+","+should_unhide+")");
    var bc = document.getElementById( "xRdf:" + panel );
    if (!bc)
      return false;
    
    var popopen = true;
    var unhide = false;

    if (sidebar_is_hidden()) {
      if (should_unhide) {
        unhide = true;
      } else {
        return false;
      }
    }

    if (sidebar_is_collapsed() && !should_popopen)
        popopen = false;

    if (bc.hasAttribute("oncommand")) {
      try {
        bc.doCommand();
      } catch (e) {
        xSidebar.toggleSidebar(bc.id);
      }
    }

    if (!popopen)
      SidebarExpandCollapse();
    return true;
  },

  previousSidebar: null,

  sidebarGetRelativePanel: function (direction) {
    // direction == 1 to view next panel, -1 to view prev panel
    var sidebarMenu =  document.getElementById("viewSidebarMenu");
    if (!sidebarMenu) {
      return;
    }
    var sItems = sidebarMenu.getElementsByAttribute("group", "sidebar");
    var sLength = sItems.length;
    var webPanel = "chrome://xsidebar/content/webpanels/web-panels.xul"
    for (var i = 0; i < sLength; i++) {
      var sItem = sItems[i];
      if (sItem.getAttribute("checked") == "true") {
        i = (i + direction) % sLength;
        i = i == -1 ? sLength -1 : i; 
        sItem = sItems[i];
        xSidebar.previousSidebar = sItem;
        var sCmd = sItem.getAttribute("oncommand");
        if (sItem.hasAttribute("oncommand")) {
          try {
            sItem.doCommand();
          } catch (e) {
            xSidebar.toggleSidebar(sItem.getAttribute("observes"));
          }
          return;
        }
      }
    }
    xSidebar.toggleSidebar('viewBookmarksSidebar');
  },

  /// Startup and Shutdown functions
  // Onbrowser startup
  // hide rdf sidebar elements
  // remove label attribute from sidebarheader id="sidebar-title-box"

  browserStartup : function () {
    // TODO: we might want to load the css/bindings before the onload fires
    xSidebar.initPrefs();
    xSidebar.loadAllStyles();
    xSidebar.buildSidebarMenu();
    var sidebarBox = document.getElementById("sidebar-box");
    if (!sidebarBox) {
      return
    }
    var sidebarSplitter = document.getElementById("sidebar-splitter");
    var sidebarTitle = document.getElementById("sidebar-title");
    var sidebarTitleBox = document.getElementById("sidebar-title-box");
    var sidebarPanelsSplitterBox = document.getElementById("sidebar-panels-splitter-box");

    xSidebar.fixupUI();
    if (window.opener && !window.opener.closed) {
      var thisWinType = document.documentElement.getAttribute("windowtype");
      var openerWinType = window.opener.document
                          .documentElement.getAttribute("windowtype");
      var openerIsSameType = (thisWinType == openerWinType);
    }
    if (window.opener && !window.opener.closed && openerIsSameType) {
      // If this window is opened from a sidebar link, the opener is the
      // sidebar box not the main window, so we need to use ".top".
      var openerSidebarBox = window.opener.top.document.getElementById("sidebar-box");
      // The opener can be the hidden window too, if we're coming from the state
      // where no windows are open, and the hidden window has no sidebar box.
      if (openerSidebarBox && !openerSidebarBox.hidden) {
        sidebarTitle.setAttribute("value",
          window.opener.top.document.getElementById("sidebar-title").getAttribute("value"));
        sidebarBox.setAttribute("width", openerSidebarBox.boxObject.width);
        var sidebarCmd = openerSidebarBox.getAttribute("sidebarcommand");
        sidebarBox.setAttribute("sidebarcommand", sidebarCmd);
        sidebarBox.setAttribute("src",
          window.opener.top.document.getElementById("sidebar").getAttribute("src"));
        gMustLoadSidebar = true;
        sidebarBox.hidden = false;
        sidebarSplitter.hidden = false;
        var isCollapsed = openerSidebarBox.collapsed;
        if (isCollapsed) {
          sidebarBox.collapsed = true;
          sidebarSplitter.setAttribute("state", "collapsed");
        }
        else if (sidebarSplitter.getAttribute("state") == "collapsed") {
          sidebarSplitter.removeAttribute("state");
        }
        document.getElementById(sidebarCmd).setAttribute("checked", "true");
      }
    }
    else {
      if (sidebarBox.hasAttribute("sidebarcommand")) {
        var commandID = sidebarBox.getAttribute("sidebarcommand");
        if (commandID) {
          var command = document.getElementById(commandID);
          if (command) {
            if (!sidebarBox.hidden) {
              gMustLoadSidebar = true;
              sidebarBox.hidden = false;
              sidebarSplitter.hidden = false;
              if (sidebarSplitter.getAttribute("state") == "collapsed")
                sidebarBox.collapsed = true;
              var title = command.getAttribute("sidebartitle");
              if (!title)
                title = command.getAttribute("label");
              // Since we are now persisting the sidebar-title, don't override it.
              if (!sidebarTitle.getAttribute("value"))
                sidebarTitle.setAttribute("value", title);
              command.setAttribute("checked", "true");
            }
          }
          else {
            // Remove the |sidebarcommand| attribute, because the element it 
            // refers to no longer exists, so we should assume this sidebar
            // panel has been uninstalled. (249883)
            sidebarBox.removeAttribute("sidebarcommand");
            // Hide sidebar since the sidebar has been uninstalled.
            sidebarBox.hidden = true;
            sidebarSplitter.hidden = true;
          }
        }
      }
    }
    if (!gMustLoadSidebar) {
      sidebarBox.hidden = true;
      sidebarSplitter.hidden = true;
      //sidebarTitleBox.hidden = true;
      sidebarPanelsSplitterBox.hidden = true;
      // sidebarBox.collapsed = true;
      // sidebarPanelsSplitterBox.collapsed = true;
    }
    setTimeout(xSidebar.delayedStartup, 0);
  },

  delayedStartup : function () {
    xSidebar.buildRDFPanelItems();
    if (gMustLoadSidebar) {
      var sidebar = document.getElementById("sidebar");
      var sidebarBox = document.getElementById("sidebar-box");
      sidebar.setAttribute("src", sidebarBox.getAttribute("src"));
    }
  },

  // If the application directory isn't user writable then our default
  // prefs are not copied into /seamonkey/defaults/pref/
  initPrefs : function () {
    var xPrefs = [
      [ "browser.preferences.instantApply", false ],
      [ "browser.preferences.animateFadeIn", false ],
      [ "accessibility.typeaheadfind.flashBar", 1 ],

      [ "extensions.xsidebar.webpanel.showmenu", true ],
      [ "extensions.xsidebar.webpanel.showzoombuttons", true ],
      [ "extensions.xsidebar.webpanel.shownavbuttons", true ],
      [ "extensions.xsidebar.history.manager.showsearchbar", true ],
      [ "extensions.xsidebar.history.manager.showadvancedsearch", true ],
      [ "extensions.xsidebar.bookmarks.manager.showadvancedsearch", true ],
      [ "extensions.xsidebar.sidebaronright.navigator", false ]
    ];
    for (var i = 0; i < xPrefs.length; i++) {
      var xPref = xPrefs[i][0];
      var xDflt = xPrefs[i][1];
      if (xSidebar.gPref.getPrefType(xPref) == xSidebar.gPref.PREF_INVALID) {
        switch(typeof xDflt) {
          case "boolean":
            xSidebar.gPref.setBoolPref(xPref, xDflt)
            break;
          case "number":
            xSidebar.gPref.setIntPref(xPref, xDflt)
            break;
          case "string":
            xSidebar.gPref.setCharPref(xPref, xDflt)
            break;
          default:
            break;
        }
      }
    }
  },

  browserShutdown : function () {
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
    var enumerator = windowManagerInterface.getEnumerator("navigator:browser");
    enumerator.getNext();
    if (!enumerator.hasMoreElements()) {
      document.persist("sidebar-box", "sidebarcommand");
      document.persist("sidebar-box", "width");
      document.persist("sidebar-box", "src");
      document.persist("sidebar-title", "value");
      document.persist("sidebar-title-box", "hidden");
      document.persist("sidebar-splitter", "hidden");
      document.persist("sidebar-splitter", "state");
    }
  },

  // Support for extensions
  extensionStartup : function () {
    xSidebar.showItem("launch-mozimage", false);

    if ("mzOpenWebFeedsSideBarPanel" in window) {
      function mzOpenWebFeedsSideBarPanel(aOpenFlag) {
        xSidebar.toggleSidebar("xRdf:urn:sidebar:panel:webfeeds", aOpenFlag);
      }
    }
  },

  /// RDF Datasource functions 

  nsIRDFLiteral : Components.interfaces.nsIRDFLiteral,
  nsIRDFResource : Components.interfaces.nsIRDFResource,
  nsIRDFRemoteDataSource : Components.interfaces.nsIRDFRemoteDataSource,
  XUL_NAMESPACE : "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
  kNCURI : "http://home.netscape.com/NC-rdf#",

  rdfS : Components.classes["@mozilla.org/rdf/rdf-service;1"]
         .getService(Components.interfaces.nsIRDFService),

  makeRDFC : function (aDS, aRes) {
    var container = Components.classes["@mozilla.org/rdf/container;1"]
                    .createInstance(Components.interfaces.nsIRDFContainer);
    container.Init(aDS, aRes);
    return container;
  },

  initDS : function (src, sDS) {
    if (!this[sDS]) {
      this[sDS] = this.getDS(src);
    }
    return this[sDS];
  },

  getDS : function (src) {
    const DIR_SERV_CONTRACTID    = "@mozilla.org/file/directory_service;1";
    const IO_SERV_CONTRACTID     = "@mozilla.org/network/io-service;1";
    const nsIProperties          = Components.interfaces.nsIProperties;
    const nsIFile                = Components.interfaces.nsIFile;
    const nsIIOService           = Components.interfaces.nsIIOService;
    const nsIFileProtocolHandler = Components.interfaces.nsIFileProtocolHandler;

    var dirS = Components.classes[DIR_SERV_CONTRACTID]
               .getService(nsIProperties);
    var dsUri;
    if (!/^rdf:/.test(src)) {
      var dsFile = dirS.get(src, nsIFile);
      if (!dsFile.exists()) {
        return null;
      }
      var ioS = Components.classes[IO_SERV_CONTRACTID]
                .getService(nsIIOService);
      var fileH = ioS.getProtocolHandler("file")
                  .QueryInterface(nsIFileProtocolHandler);
      dsUri = fileH.getURLSpecFromFile(dsFile);
    } else {
      dsUri = src;
    }
    try {
      var ds = this.rdfS.GetDataSourceBlocking(dsUri);
      return ds;
    }
    catch (e) {
      dump("\nxSidebar:getDS: "+e);
      return null;
    }

  },

  initEMDS : function() {
    if (!this.chromeDS) {
      this.chromeDS = Components.classes["@mozilla.org/extensions/manager;1"]
                                .getService(Components.interfaces.nsIExtensionManager)
                                .datasource;
    }
    return this.chromeDS;
  },

  /// Sidebar Menu

  panelDS : null,

  buildSidebarMenu : function () {
    xSidebar.buildRDFPanelItems();
    var xSidebarMenu = document.getElementById("xsidebar-panel-viewer-popup");
    var sidebarMenu =  document.getElementById("viewSidebarMenu");
    if (xSidebarMenu && sidebarMenu) {
      while (xSidebarMenu.hasChildNodes()) {
        xSidebarMenu.removeChild(xSidebarMenu.firstChild);
      }
    // cloning the whole menu in one step causes Mozilla 1.7.12 to crash
    // when the cloned menu is used. If we don't want to support Moz 1.7
    // we can simplify the following code for Seamonkey only builds.
      var newItem;
      for (var ii = 0; ii < sidebarMenu.childNodes.length; ii++) {
        newItem = sidebarMenu.childNodes[ii].cloneNode(true);
        xSidebarMenu.appendChild(newItem);
      }
    }
  },

  buildRDFPanelItems : function () {

    var rCurrentPanelList = this.rdfS.GetResource("urn:sidebar:current-panel-list");
    var rPanelList        = this.rdfS.GetResource(this.kNCURI + "panel-list");

    var dataS = this.initDS("UPnls", "panelDS");
    var panelList = dataS.GetTarget(rCurrentPanelList, rPanelList, true);
    if (!panelList) {
      return;
    }
    panelList.QueryInterface(this.nsIRDFResource);
    //dump(xulplanet_show_rdf_ds(PanelUri));

    var sidebarMenu =  document.getElementById("viewSidebarMenu");
    if (!sidebarMenu) {
      return;
    }

    var checkedNode = xSidebar.deleteRdfMenuItems();

    var sNode = document.createElementNS(this.XUL_NAMESPACE, "menuseparator");
    sNode.setAttribute("xRdfgroup", "true");
    xSidebar.sortSidebarMenuItems(sNode.cloneNode(true));
    sidebarMenu.appendChild(sNode);

    var localPanels = xSidebar.getBroadcasterUrls();

    var bsNode = document.getElementById("mainBroadcasterSet");
  
    var bNode = document.createElementNS(this.XUL_NAMESPACE, "broadcaster");
    bNode.setAttribute("autoCheck", "false");
    bNode.setAttribute("type",      "checkbox");
    bNode.setAttribute("group",     "sidebar");
    bNode.setAttribute("autoCheck", "false");
    bNode.setAttribute("xRdfgroup", "true");
    
    var mNode = document.createElementNS(this.XUL_NAMESPACE, "menuitem");
    mNode.setAttribute("xRdfgroup", "true");
    
    var tNode, tCmd;

    var container = this.makeRDFC(dataS, panelList);
    var panels = container.GetElements();
    var panel, panelAbout, panelTitle, panelContent;
    var rTitle = this.rdfS.GetResource(this.kNCURI + "title");
    var rContent = this.rdfS.GetResource(this.kNCURI + "content");
    while (panels.hasMoreElements()) {
      panel = panels.getNext().QueryInterface(this.nsIRDFResource);
      panelAbout = panel.Value;
      panelTitle = dataS
        .GetTarget(panel, rTitle ,true)
        .QueryInterface(this.nsIRDFLiteral);
      panelContent = dataS
        .GetTarget(panel, rContent ,true)
        .QueryInterface(this.nsIRDFLiteral);
/*
      dump("\nxsidebar " + "\n");
      dump("about: " + panelAbout
           + " title: " + panelTitle.Value
           + " content: " + panelContent.Value + "\n");
*/
      if (localPanels.indexOf(panelContent.Value) < 0) {

        tNode = bNode.cloneNode(true);
        panelAbout = "xRdf:" + panelAbout;
        tNode.id = panelAbout;
        tNode.setAttribute("label", panelTitle.Value);
        tNode.setAttribute("sidebarurl", panelContent.Value);
        if (xSidebar.mustSandbox(panelContent.Value)) {
          tCmd = "xSidebar.openWebPanel('" + panelTitle.Value + "', '"
                 + panelContent.Value + "', '" + panelAbout + "');";
        } else {
          tCmd = "xSidebar.toggleSidebar('" + panelAbout + "');";
        }
        tNode.setAttribute("oncommand", tCmd);
        if (checkedNode && tNode.id == checkedNode) {
          tNode.setAttribute("checked", "true");
        }
        bsNode.appendChild(tNode);

        tNode = mNode.cloneNode(true);
        tNode.setAttribute("observes", panelAbout);
        sidebarMenu.appendChild(tNode);
      }
    }
    // Moji mailnews (tbmoji.xul) replaces toggleSidebar() with it's own
    // strange version. Let's grab it back with a saner version, i.e. ours.
    // Have contributed sidebar code to Moji 0.9a2 for better compatibility
    // with xSidebar.
    toggleSidebar = function toggleSidebar(aCommandID, forceOpen) {
      xSidebar.toggleSidebar(aCommandID, forceOpen);
    }
  },

  deleteRdfMenuItems : function () {
    var rNodes = top.document.getElementsByAttribute( "xRdfgroup", "true");
    var checkedNode;
    for (var ii = rNodes.length - 1; ii > -1; ii--) {
      var rNode = rNodes[ii];
      if (rNode.localName == "broadcaster" &&
          rNode.getAttribute("checked")) {
        checkedNode = rNode.id;
      }
      rNode.parentNode.removeChild(rNodes[ii]);
    }
    return checkedNode;
  },

  sortSidebarMenuItems : function (sNode) {
    var mItems = new Array();
    var sidebarMenu =  document.getElementById("viewSidebarMenu");
    if (!sidebarMenu) {
      return;
    }
    var cNodes = sidebarMenu.childNodes;
    for (var i = 0; i < cNodes.length; i++) {
      var element = cNodes[i];
      if (!element.getAttribute("xsbinternal")) {
        mItems.push([element.getAttribute("label"), element]);
      }
    }
    mItems.sort(this.extSort);
    if (mItems.length > 0) {
      sidebarMenu.appendChild(sNode);
    }
    for (var ii = 0; ii < mItems.length; ii++) {
      sidebarMenu.appendChild(mItems[ii][1]);
    }
  },

  getBroadcasterUrls : function () {
    var bsNode = document.getElementById("mainBroadcasterSet");
    var bNodes = bsNode.getElementsByAttribute("group", "sidebar");
    var tURI;
    var bURIs = [];
    for (var ii = bNodes.length - 1; ii > -1; ii--) {
      tURI = bNodes[ii].getAttribute("sidebarurl");
      if (tURI) {
        bURIs.push(tURI);
      }
    }
    return bURIs;
  },

  goPreferences : function (containerID, paneURL, itemID) {
    if(xSidebar.versionChecker.compare(xSidebar.appInfo.version, "2.0a") < 0) {
      if (arguments.length < 1) {
        containerID = "xsidebarPrefTree";
        paneURL = "chrome://xsidebar/content/preferences/xsidebarGeneral.xul";
        itemID = "xsidebarPrefTree";
    }
      goPreferences(containerID, paneURL, itemID);
    }
    else {
      goPreferences("xsidebar_pane");
    }
  },

  /// WebPanel functions

  toggleWebPanel : function (aWebPanel) {
    var webPanel = document.getElementById("viewWebPanelsSidebar");
    if (webPanel)
      webPanel.removeAttribute("rdfpanel");
    xSidebar.toggleSidebar(aWebPanel);
  },

  // called from FF contentAreaClick and FF bookmarks.js
  openWebPanel : function (aTitle, aURI, aRdfPanel) {
    var webPanel = document.getElementById("viewWebPanelsSidebar");
    if (aRdfPanel)
      webPanel.setAttribute("rdfpanel", aRdfPanel);
    else
      webPanel.removeAttribute("rdfpanel");
    // Ensure that the web panels sidebar is open.
    xSidebar.toggleSidebar('viewWebPanelsSidebar', true);

    // Set the title of the panel.
    if (!aTitle)
      aTitle = document.getElementById("sidebar-title").getAttribute("defaulttitle");
    document.getElementById("sidebar-title").value = aTitle;

    // Tell the Web Panels sidebar to load the bookmark.
    var sidebar = document.getElementById("sidebar");
    if (sidebar.docShell &&
        sidebar.contentDocument &&
        sidebar.contentDocument.getElementById('web-panels-browser')) {
      sidebar.contentWindow.loadWebPanel(aURI);
      if (gWebPanelURI) {
        gWebPanelURI = "";
        sidebar.removeEventListener("load", xSidebar.asyncOpenWebPanel, true);
      }
    }
    else {
      // The panel is still being constructed.  Attach an onload handler.
      if (!gWebPanelURI)
        sidebar.addEventListener("load", xSidebar.asyncOpenWebPanel, true);
      gWebPanelURI = aURI;
    }
  },

  asyncOpenWebPanel : function (event) {
    var sidebar = document.getElementById("sidebar");
    if (gWebPanelURI &&
        sidebar.contentDocument &&
        sidebar.contentDocument.getElementById('web-panels-browser'))
      sidebar.contentWindow.loadWebPanel(gWebPanelURI);
    gWebPanelURI = "";
    sidebar.removeEventListener("load", xSidebar.asyncOpenWebPanel, true);
  },

  mustSandbox : function (urlString) {
    return !urlString.match(/^chrome:/);
  },

  addPanel : function (title, url, custom) {
    var xsbSS = Components.classes["@mozilla.org/sidebar;1"]
                .getService(Components.interfaces.nsISidebar);
    this.initDS("UPnls", "panelDS");
    if (/(^chrome:|^resource:)/i.test(url))
      this.addPanelInternal(title, url, custom);
    else
      xsbSS.addPanel(title, url, custom);
  },

  addPanelInternal : function (title, url, custom) {
    //addPanelInternal() allows chrome: and resource: urls as well.
    if (!/(^http:|^ftp:|^https:|^chrome:|^resource:)/i.test(url))
      return;

    var rCurrentPanelList = this.rdfS.GetResource("urn:sidebar:current-panel-list");
    var rPanelList        = this.rdfS.GetResource(this.kNCURI + "panel-list");
    var urn               = "urn:sidebar:3rdparty-panel:" + url;
    var rPanel            = this.rdfS.GetResource(urn);

    var panelDS = this.initDS("UPnls", "panelDS");

    var panelList = panelDS.GetTarget(rCurrentPanelList, rPanelList, true);
    var container = this.makeRDFC(panelDS, panelList);
    if (container.IndexOf(rPanel) != -1)
      return;

    panelDS.Assert(rPanel,
                   this.rdfS.GetResource(this.kNCURI + "title"),
                   this.rdfS.GetLiteral(title),
                   true);
    panelDS.Assert(rPanel,
                   this.rdfS.GetResource(this.kNCURI + "content"),
                   this.rdfS.GetLiteral(url),
                   true);
    if (custom)
      panelDS.Assert(rPanel,
                     this.rdfS.GetResource(this.kNCURI + "customize"),
                     this.rdfS.GetLiteral(custom),
                     true);
    container.AppendElement(rPanel);

    var rRefresh = this.rdfS.GetResource(this.kNCURI + "refresh");
    var rTrue = this.rdfS.GetLiteral("true");

    panelDS.Assert(rCurrentPanelList, rRefresh, rTrue, true);
    panelDS.Unassert(rCurrentPanelList, rRefresh, rTrue);
    panelDS.QueryInterface(this.nsIRDFRemoteDataSource).Flush();
  },

  /// ContextMenu functions

  contextMenuInit : function () {
    var cm = document.getElementById("contentAreaContextMenu");
    if (cm) {
      cm.addEventListener("popupshowing",xSidebar.contextMenu,false);
    }

    // Temporarily put the contentareaclick init here.
    var tb = document.getElementById("content");
    if (tb &&
        tb.getAttribute("onclick") &&
        tb.getAttribute("contentcontextmenu") &&
        tb.getAttribute("contentcontextmenu") == "contentAreaContextMenu") {
      tb.setAttribute("onclick","return xSidebar.contentAreaClick(event);");
    }
  },

  contextMenu : function () {
      var cm = gContextMenu;
      var showOpen = cm.onSaveableLink || ( cm.inDirList && cm.onLink );
      var showView = !( this.inDirList || this.onImage || this.isTextSelected
        || this.onLink || this.onTextInput );
      cm.showItem("context-xsbOpenLinkInSidebar",   showOpen);
      cm.showItem("context-xsbViewSourceInSidebar", showView);
      cm.showItem("context-xsbViewPageInSidebar",   showView);
      cm.showItem("context-xsbAddPageToSidebars",   showView);
  },

  openLinkInSidebar : function(gCm) {
    var url = (typeof(gCm.linkURL) == "function") ?
      gCm.linkURL() : gCm.linkURL;
    xSidebar.openWebPanel(gCm.linkText(),url);
  },

  openPageInSidebar : function() {
    xSidebar.openWebPanel(window.content.document.title,
      window.content.location);
  },

  viewSourceInSidebar : function() {
    xSidebar.openWebPanel(window.content.location,
      "view-source:" + window.content.location);
  },

  addPageToCurrentPanelList : function () {
    xSidebar.addPanel(window.content.document.title,
      window.content.location, "");
  },

  // XXX: this isn't working. Need to debug.
  togglePageSource : function (aDocument) {
  // From BrowserViewSourceOfDocument()
    var docCharset;
    var pageCookie;
    var webNav;
    // Get the document charset
    docCharset = "charset=" + aDocument.characterSet;
    // Get the nsIWebNavigation associated with the document
    try {
        var win;
        var ifRequestor;
        // Get the DOMWindow for the requested document.  If the DOMWindow
        // cannot be found, then just use the content window...
        // XXX:  This is a bit of a hack...
        win = aDocument.defaultView;
        if (win == window) {
          win = content;
        }
        ifRequestor = win.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
        webNav = ifRequestor.getInterface(Components.interfaces.nsIWebNavigation);
    } catch(err) {
        // If nsIWebNavigation cannot be found, just get the one for the whole
        // window...
        webNav = getWebNavigation();
    }
    // Get the 'PageDescriptor' for the current document. This allows the
    // view-source to access the cached copy of the content rather than
    // refetching it from the network...
    try{
    var PageLoader = webNav.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
    pageCookie = PageLoader.currentDescriptor;
    } catch(err) {
    // If no page descriptor is available, just use the view-source URL...
    }
    var sidebar = document.getElementById("sidebar");
    sidebar.setAttribute("windowarguments",
      (webNav.currentURI.spec, docCharset, pageCookie));
    xSidebar.toggleSidebar("viewSourceSidebar");
  },


  /// ContextAreaClick functions

  // Content Area Click from firefox browser.js - mimimal port
  contentAreaClick : function (event, fieldNormalClicks) {

    if (!event.isTrusted) {
      return true;
    }

    var linkNode = null;
    var isKeyPress = (event.type == "keypress");
    var isKeyCommand = (event.type == "command");
    var target = isKeyCommand ? document.commandDispatcher.focusedElement : event.target;

    if (target instanceof HTMLAnchorElement ||
        target instanceof HTMLAreaElement ||
        target instanceof HTMLLinkElement) {
      if (target.hasAttribute("href"))
        linkNode = target;

      // xxxmpc: this is kind of a hack to work around a Gecko bug (see bug 266932)
      // we're going to walk up the DOM looking for a parent link node,
      // this shouldn't be necessary, but we're matching the existing behaviour for left click
      var parent = target.parentNode;
      while (parent) {
        if (parent instanceof HTMLAnchorElement ||
            parent instanceof HTMLAreaElement ||
            parent instanceof HTMLLinkElement) {
          if (parent.hasAttribute("href"))
            linkNode = parent;
        }
        parent = parent.parentNode;
      }
    }
    else if ( target instanceof HTMLInputElement
            && (event.target.type == "text") // text field
            && !isKeyPress       // not a key event
            && !isKeyCommand     // not a command event: see mozilla bug 185270
            && event.detail == 2 // double click
            && event.button == 0 // left mouse button
            && event.target.value.length == 0 // no text has been entered
            && "@mozilla.org/wallet/wallet-service;1" in Components.classes // wallet is available
    ) {
      prefillTextBox(target); // prefill the empty text field if possible
    }
    else {
      linkNode = event.originalTarget;
      while (linkNode && !(linkNode instanceof HTMLAnchorElement))
        linkNode = linkNode.parentNode;
      // <a> cannot be nested.  So if we find an anchor without an
      // href, there is no useful <a> around the target
      if (linkNode && !linkNode.hasAttribute("href"))
        linkNode = null;
    }
    var wrapper = null;
    if (linkNode) {
      wrapper = linkNode;
      if (event.button == 0 && !event.ctrlKey && !event.shiftKey &&
          !event.altKey && !event.metaKey) {
        // A Web panel's links should target the main content area.  Do this
        // if no modifier keys are down and if there's no target or the target equals
        // _main (the IE convention) or _content (the Mozilla convention).
        // XXX Now that markLinkVisited is gone, we may not need to field _main and
        // _content here.
        target = wrapper.getAttribute("target");
        var docWrapper = wrapper.ownerDocument;
        var locWrapper = docWrapper.location;

        if (linkNode.getAttribute("rel") == "sidebar") {
           // This is the Opera convention for a special link that - when clicked - allows
           // you to add a sidebar panel.  We support the Opera convention here.  The link's
           // title attribute contains the title that should be used for the sidebar panel.
          xSidebar.addPanel(wrapper.getAttribute("title"), wrapper.href, "");
          event.preventDefault();
          return false;
        }
        else if (target == "_search") {
          // Used in WinIE as a way of transiently loading pages in a sidebar.  We
          // mimic that WinIE functionality here and also load the page transiently.

          // javascript links targeting the sidebar shouldn't be allowed
          // we copied this from IE, and IE blocks this completely
          if (wrapper.href.substr(0, 11) === "javascript:")
            return false;

          // data: URIs are just as dangerous
          if (wrapper.href.substr(0, 5) === "data:")
            return false;

          if (!xSidebar.webPanelSecurityCheck(locWrapper.href, wrapper.href))
            return false;

          xSidebar.openWebPanel(wrapper.getAttribute("title"), wrapper.href);
          event.preventDefault();
          return false;
        }
      }
    }

    return contentAreaClick(event);
  },

  webPanelSecurityCheck : function (aSourceURL, aDestURL) {
    var sourceURI = makeURI(aSourceURL);
    var destURI = makeURI(aDestURL);

    const nsIScriptSecurityManager = Components.interfaces.nsIScriptSecurityManager;
    var secMan = Components.classes["@mozilla.org/scriptsecuritymanager;1"]
                           .getService(nsIScriptSecurityManager);
    try {
      secMan.checkLoadURI(sourceURI, destURI, nsIScriptSecurityManager.STANDARD);
    } catch (e) {
      return false;
    }
    return true;
  },

  /// Extensions

  chromeDS : null,

  isEM : ("nsIExtensionManager" in Components.interfaces) &&
         ("@mozilla.org/extensions/manager;1" in Components.classes),

  buildExtOptionsMenu : function (event) {

    var kCRURI = "http://www.mozilla.org/rdf/chrome#";
    var ref = this.rdfS.GetResource("urn:mozilla:package:root");
    var rName = this.rdfS.GetResource(kCRURI + "name");
    var rDispName = this.rdfS.GetResource(kCRURI + "displayName");
    var rSettings = this.rdfS.GetResource(kCRURI + "settingsURL");
    var rIcon = this.rdfS.GetResource(kCRURI + "iconURL");
    var cDS;

    if (xSidebar.isEM) {
      cDS = this.initEMDS();
      kCRURI = "http://www.mozilla.org/2004/em-rdf#";
      ref = this.rdfS.GetResource("urn:mozilla:item:root");
      rName = this.rdfS.GetResource(kCRURI + "name");
      rDispName = this.rdfS.GetResource(kCRURI + "displayName");
      rSettings = this.rdfS.GetResource(kCRURI + "optionsURL");
      rIcon = this.rdfS.GetResource(kCRURI + "iconURL");
    }
    else {
      cDS = this.initDS("rdf:chrome", "chromeDS");
    }
    if (!cDS) {
      return;
    }

    var container = this.makeRDFC(cDS, ref);
    var packages = container.GetElements();

    var pack, cName, cDispName, cOptions, cIcon;
    var eItems = new Array();

    while (packages.hasMoreElements()) {
      pack = packages.getNext().QueryInterface(this.nsIRDFResource);
      cName = cDS.GetTarget(pack, rName, true);
      if (!(cName instanceof this.nsIRDFLiteral))
        continue;
      cDispName = cDS.GetTarget(pack, rDispName, true);
      if (cDispName)
        cDispName.QueryInterface(this.nsIRDFLiteral);
      else
        cDispName = cName;
      cIcon = cDS.GetTarget(pack, rIcon, true)
      cIcon = (cIcon instanceof this.nsIRDFLiteral) ? cIcon.Value : null;
      cOptions = cDS.GetTarget(pack, rSettings, true)
      if (cOptions instanceof this.nsIRDFLiteral) {
        // cOptions.QueryInterface(this.nsIRDFLiteral);
        eItems.push([cDispName.Value, cOptions.Value, cIcon]);
      }
    }
    eItems.sort(this.extSort);

    var popup = event.target;
    var eNodes = popup.getElementsByAttribute( "xExtgroup", "true");
    for (var ii = eNodes.length - 1; ii > -1; ii--) {
        eNodes[ii].parentNode.removeChild(eNodes[ii]);
    }

    var sNode = document.createElementNS(this.XUL_NAMESPACE, "menuseparator");
    sNode.setAttribute("xExtgroup", "true");
    var mNode = document.createElementNS(this.XUL_NAMESPACE, "menuitem");
    mNode.setAttribute("xExtgroup", "true");
    mNode.setAttribute("class", "menuitem-iconic xsidebar-options-menu");

    if (eItems.length > 0) {
      popup.appendChild(sNode);
    }
    for (var jj = 0; jj < eItems.length; jj++) {
      //var tNode = mNode.cloneNode(true);
      var tNode = document.createElementNS(this.XUL_NAMESPACE, "menuitem");
      tNode.setAttribute("xExtgroup", "true");
      tNode.setAttribute("class", "menuitem-iconic xsidebar-options-menu");
      
      tNode.setAttribute("label", eItems[jj][0]);
      tNode.setAttribute("optionsURL", eItems[jj][1]);
      if (eItems[jj][2])
        tNode.setAttribute("image", eItems[jj][2]);
      tNode.setAttribute("oncommand", "xSidebar.cmd_options(event.target);");
      popup.appendChild(tNode);
    }
    return;
  },

  extSort : function (a, b) {
    var s1 = a[0].toLowerCase();
    var s2 = b[0].toLowerCase();
    var rv = 0;
    if (s1 < s2) {
      rv = -1;
    }
    else if (s1 > s2) {
      rv = 1;
    }
    return rv;
  },

  // Firefox Extension Manager functions

    cmd_options: function (aSelectedItem)
    {
      if (!aSelectedItem) return;
      var optionsURL = aSelectedItem.getAttribute("optionsURL");
      if (optionsURL == "")
        return;

      var windows = Components.classes['@mozilla.org/appshell/window-mediator;1']
                              .getService(Components.interfaces.nsIWindowMediator)
                              .getEnumerator(null);
      while (windows.hasMoreElements()) {
        var win = windows.getNext();
        if (win.document.documentURI == optionsURL) {
          win.focus();
          return;
        }
      }

      var features;
      try {
        var instantApply = this.gPref.getBoolPref("browser.preferences.instantApply");
        //features = "chrome,titlebar,toolbar,centerscreen" + (instantApply ? ",dialog=no" : ",modal");
        features = "chrome,titlebar,toolbar,centerscreen,resizable" + (instantApply ? ",dialog=no" : "");
      }
      catch (e) {
        //features = "chrome,titlebar,toolbar,centerscreen,modal";
        features = "chrome,titlebar,toolbar,centerscreen,resizable";
      }
      openDialog(optionsURL, "", features);
    },


  /// Aviary findbar functions
  isFindBarVisible : function () {
    var findBar = document.getElementById("FindToolbar");
      return findBar ? !findBar.hidden : false;
  },

  /// Stylesheet support functions

  loadStylesheet : function (css) {
    if(!"@mozilla.org/content/style-sheet-service;1" in Components.classes) {
      dump("\nxSidebar: stylesheet service not defined.\n");
      return;
    }
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
              .getService(Components.interfaces.nsIStyleSheetService);
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
              .getService(Components.interfaces.nsIIOService);
    var uss = ios.newURI(css, null, null);
    if(!sss.sheetRegistered(uss, sss.USER_SHEET)) {
      sss.loadAndRegisterSheet(uss, sss.USER_SHEET);
      //dump("\nxSidebar - stylesheet installed: "+css);
    } else {
      //dump("\nxSidebar - stylesheet already installed: "+css);
    }
  },

  loadAllStyles : function () {
    var ss = [];
    if(xSidebar.versionChecker.compare(xSidebar.appInfo.version, "2.0a") < 0) {
      ss = ["chrome://xsidebar/content/global/xul.css",
            "chrome://xsidebar/content/global/autocomplete.css",
            "chrome://xsidebar/content/global/preferences.css",
            "chrome://xsidebar/content/global/richlistbox.css"];
      if (!("multizillaContextMenu" in window))
        ss.push("chrome://xsidebar/content/global/notification.css");
    }
    for( var ii = 0; ii < ss.length; ii++) {
      xSidebar.loadStylesheet(ss[ii]);
    }
  },

  /// Pref Observer

  prefOnRightObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed") {
        var isRight = xSidebar.gPref.getBoolPref("extensions.xsidebar.sidebaronright.navigator");
        xSidebar.sidebarOnRight(isRight);
      }
    },

    QueryInterface : function (aIID) {
      if (aIID.equals(Components.interfaces.nsIObserver) || 
      aIID.equals(Components.interfaces.nsISupports) ||
      aIID.equals(Components.interfaces.nsISupportsWeakReference))
        return this;
      throw Components.results.NS_NOINTERFACE;
    }
  },

  addPrefOnRightObserver : function () {
    window.removeEventListener("load", xSidebar.addPrefOnRightObserver, false);
    xSidebar.sidebarOnRight(xSidebar.gPref
      .getBoolPref("extensions.xsidebar.sidebaronright.navigator"));
    xSidebar.gPref.addObserver("extensions.xsidebar.sidebaronright.",
      xSidebar.prefOnRightObserver, true);
  },

  removePrefOnRightObserver : function () {
    if (!xSidebar.gPref) return;
    xSidebar.gPref.removeObserver("extensions.xsidebar.sidebaronright.",
      xSidebar.prefOnRightObserver);
  },

  sidebarOnRight : function (isRight) {
    var sidebarBox = document.getElementById("sidebar-box");
    if (sidebarBox && sidebarBox.parentNode) {
      var container = sidebarBox.parentNode;
      if (isRight) {
        container.setAttribute("xsidebaronright", "true");
        container.setAttribute("dir", "reverse");
      }
      else {
        container.setAttribute("xsidebaronright", "false");
        container.setAttribute("dir", "normal");
        container.removeAttribute("dir");
        setTimeout(xSidebar.delayedSidebarOnLeft, 0);
      }
    }
  },

  delayedSidebarOnLeft : function () {
    var container = document.getElementById("sidebar-box").parentNode;
    container.setAttribute("xsidebaronright", "false");
    container.setAttribute("dir", "normal");
    container.removeAttribute("dir");
  },


  /// Drag and Drop functions

  dragDropSecurityCheck: function (aEvent, aDragSession, aUri) {
    var sourceDoc = aDragSession.sourceDocument;

    if (sourceDoc) {

      var uriStr = aUri.replace(/^\s*|\s*$/g, '');
      var uri = null;

      try {
        uri = Components.classes["@mozilla.org/network/io-service;1"]
          .getService(Components.interfaces.nsIIOService)
          .newURI(uriStr, null, null);
      } catch (e) {
      }

      if (uri) {
        // aUri is a URI, do the security check.
        var sourceURI = sourceDoc.documentURI;

        const nsIScriptSecurityManager =
          Components.interfaces.nsIScriptSecurityManager;
        var secMan =
          Components.classes["@mozilla.org/scriptsecuritymanager;1"]
          .getService(nsIScriptSecurityManager);

        try {
          secMan.checkLoadURIStr(sourceURI, uriStr,
                                 nsIScriptSecurityManager.STANDARD);
        } catch (e) {
          // Stop event propagation right here.
          aEvent.stopPropagation();

          throw "Drop of " + aUri + " denied.";
        }
      }
    }
  },

  /// Misc support functions

  showItem : function ( itemOrId, show ) {
    var item = itemOrId.constructor == String ? document.getElementById(itemOrId) : itemOrId;
    if (item) 
      item.hidden = !show;
  },

  gPref : Components.classes["@mozilla.org/preferences-service;1"]
               .getService(Components.interfaces.nsIPrefService)
               .QueryInterface(Components.interfaces.nsIPrefBranch2)
               .QueryInterface(Components.interfaces.nsIPrefBranch),

  appInfo : Components.classes["@mozilla.org/xre/app-info;1"]
                      .getService(Components.interfaces.nsIXULAppInfo),

  versionChecker : Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                             .getService(Components.interfaces.nsIVersionComparator),

  xsbStatus : "installed"
}

/// ArrayExtras for older browsers that don't support these array methods.

// From http://erik.eae.net/archives/2005/06/05/17.53.19/
// From http://erik.eae.net/playground/arrayextras/
// Mozilla 1.8 has support for indexOf, lastIndexOf, forEach, filter, map, some, every
// http://developer-test.mozilla.org/docs/Core_JavaScript_1.5_Reference:Objects:Array:IndexOf
/* Not Needed for Gecko 1.8 and above
if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function (obj, fromIndex) {
    if (fromIndex == null) {
      fromIndex = 0;
    } else if (fromIndex < 0) {
      fromIndex = Math.max(0, this.length + fromIndex);
    }
    for (var i = fromIndex; i < this.length; i++) {
      if (this[i] === obj)
        return i;
    }
    return -1;
  };
}
*/

/// Debug functions

// From XULPlanet 
function xulplanet_show_rdf_ds(datasource_name)
{
  var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);
  var ds = rdfService.GetDataSourceBlocking(datasource_name);
  var t="";
  var all_res=ds.GetAllResources();
  for(var r=0; all_res.hasMoreElements(); r++)
  {
    if(t.length>5000) break;  // comment out for unlimited output
    var res=all_res.getNext();
    // res is a resource
    if (res instanceof Components.interfaces.nsIRDFResource)
    {
      var tr=r + " R: "+res.Value+"\n";
      var ps= ds.ArcLabelsOut(res);
      while (ps.hasMoreElements())
      {
        var predicate = ps.getNext();
        // predicate is a resource
        if (predicate instanceof Components.interfaces.nsIRDFResource)
        {
          tr+="  -R:  "+predicate.Value+"\n";
          var ts= ds.GetTargets(res, predicate, true);
          while (ts.hasMoreElements())
          {
            var target = ts.getNext();
            // target is either a resource, a literal or a typed-literal
            if (target instanceof Components.interfaces.nsIRDFResource)
              tr+="   >R: "+target.Value+"\n";
            else
            if (target instanceof Components.interfaces.nsIRDFLiteral)
              tr+="    >L: "+target.Value+"\n";
            else
            if (target instanceof Components.interfaces.nsIRDFBlob)
              tr+="    >BLOB length:"+target.length+"\n";
            else
            if (target instanceof Components.interfaces.nsIRDFInt)
              tr+="    >INT:"+target.Value+"\n";
            else
            if (target instanceof Components.interfaces.nsIRDFDate)
              tr+="    >DATE: "+target.Value+"\n";
            else
            if (target instanceof Components.interfaces.nsIRDFNode)
              tr+="    >Node \n";
            else
              tr+="    >Unknown\n";
          }
        } // end predicate-res
     } // end ps
     t+=tr+"\n";
    } else // should never happen
    if (res instanceof Components.interfaces.nsIRDFLiteral)
    {
      t+=r + "L: "+res.Value+"\n";
    } else
      t+=r + "?: "+"\n";
  }
  return t;
}